Unit ASP5A_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASP5A(var A :Array of Real; var B :Array of Real;
                var X :Array of Real; N :Integer; M :Integer;
                Z :Integer);

implementation

procedure ASP5A(var A :Array of Real; var B :Array of Real;
                var X :Array of Real; N :Integer; M :Integer;
                Z :Integer);
var
I,J,K,L :Integer;
R1,R2,R,P,T,C,S,A1,A2 :Real;
D,D1 :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17;
begin
for I:=1 to N do
 begin
_1:
  X[I-1] := B[I-1];
 end;
if ( Z <> 1 ) 
 then goto _10;
for K:=1 to N do
 begin
  L := K+1;
  if ( L > M ) 
   then goto _9;
  for J:=L to M do
   begin
    R2 := A[(K-1)+(J-1)*N];
    if ( R2 = 0.0 ) 
     then goto _8;
    R1 := A[(K-1)+(K-1)*N];
    A1 := Abs(R1);
    A2 := Abs(R2);
    if ( A1 <> 0.0 ) 
     then goto _2;
    T := 1;
    A[(K-1)+(K-1)*N] := A[(K-1)+(J-1)*N];
    goto _6;
_2:
    if ( A1 <= A2 ) 
     then goto _3;
    P := R2/R1;
    R := Sqrt(1.0+P*P);
    T := P/(R+1.0);
    A[(K-1)+(K-1)*N] := R*R1;
    goto _6;
_3:
    P := R1/R2;
    R := Sqrt(1.0+P*P);
    T := 1.0/(R+Abs(P));
    if ( P < 0.0 ) 
     then T := -T;
    if ( R1 ) < 0
     then goto _4
     else if ( R1 ) > 0
           then goto _5
           else goto _5;
_4:
    A[(K-1)+(K-1)*N] := -R*A2;
    goto _6;
_5:
    A[(K-1)+(K-1)*N] := R*A2;
_6:
    A[(K-1)+(J-1)*N] := T;
    R := T*T;
    R1 := 1.0/(1.0+R);
    C := (1.0-R)*R1;
    S := (T+T)*R1;
    if ( L > N ) 
     then goto _8;
    for I:=L to N do
     begin
      R1 := A[(I-1)+(K-1)*N];
      R2 := A[(I-1)+(J-1)*N];
      A[(I-1)+(K-1)*N] := R1*C+R2*S;
      A[(I-1)+(J-1)*N] := R2*C-R1*S;
_7:
     end;
_8:
   end;
_9:
 end;
_10:
X[0] := X[0]/A[0+0*N];
if ( N = 1 ) 
 then goto _13;
for K:=2 to N do
 begin
  L := K-1;
  D := 0.0;
  for J:=1 to L do
   begin
    D1 := A[(K-1)+(J-1)*N];
_11:
    D := D+D1*X[J-1];
   end;
  D1 := X[K-1];
  D := D1-D;
  R2 := D;
_12:
  X[K-1] := R2/A[(K-1)+(K-1)*N];
 end;
_13:
K := N;
if ( N = M ) 
 then goto _17;
J := N+1;
for I:=J to M do
 begin
_14:
  X[I-1] := 0.0;
 end;
_15:
J := M;
_16:
T := A[(K-1)+(J-1)*N];
R := T*T;
R1 := 1.0/(1.0+R);
C := (1.0-R)*R1;
S := (T+T)*R1;
R1 := X[K-1];
R2 := X[J-1];
X[K-1] := C*R1-S*R2;
X[J-1] := S*R1+C*R2;
J := J-1;
if ( J > K ) 
 then goto _16;
_17:
K := K-1;
if ( K > 0 ) 
 then goto _15;
end;

end.
